3 # Copyright (c) 2005 Junio C Hamano.
6 USAGE
='[--interactive | -i] [-v] [--onto <newbase>] [<upstream>|--root] [<branch>]'
7 LONG_USAGE
='git-rebase replaces <branch> with a new branch of the
8 same name. When the --onto option is provided the new branch starts
9 out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
10 It then attempts to create a new commit for each commit from the original
11 <branch> that does not exist in the <upstream> branch.
13 It is possible that a merge failure will prevent this process from being
14 completely automatic. You will have to resolve any such merge failure
15 and run git rebase --continue. Another option is to bypass the commit
16 that caused the merge failure with git rebase --skip. To restore the
17 original <branch> and remove the .git/rebase-apply working files, use the
18 command git rebase --abort instead.
20 Note that if <branch> is not specified on the command line, the
21 currently checked out branch is used.
23 Example: git-rebase master~1 topic
25 A---B---C topic A'\''--B'\''--C'\'' topic
27 D---E---F---G master D---E---F---G master
33 set_reflog_action rebase
37 OK_TO_SKIP_PRE_REBASE
=
39 When you have resolved this problem run \"git rebase --continue\".
40 If you would prefer to skip this patch, instead run \"git rebase --skip\".
41 To restore the original branch and stop rebasing run \"git rebase --abort\".
46 dotest
="$GIT_DIR"/rebase-merge
53 test -n "$prev_head" || die
"prev_head must be defined"
54 test -d "$dotest" || die
"$dotest directory does not exist"
56 unmerged
=$
(git ls-files
-u)
57 if test -n "$unmerged"
59 echo "You still have unmerged paths in your index"
60 echo "did you forget to use git add?"
64 cmt
=`cat "$dotest/current"`
65 if ! git diff-index
--quiet --ignore-submodules HEAD
--
67 if ! git commit
--no-verify -C "$cmt"
69 echo "Commit failed, please do not call \"git commit\""
70 echo "directly, but instead do one of the following: "
73 printf "Committed: %0${prec}d " $msgnum
75 printf "Already applied: %0${prec}d " $msgnum
77 git rev-list
--pretty=oneline
-1 "$cmt" |
sed -e 's/^[^ ]* //'
79 prev_head
=`git rev-parse HEAD^0`
80 # save the resulting commit so we can read-tree on it later
81 echo "$prev_head" > "$dotest/prev_head"
83 # onto the next patch:
84 msgnum
=$
(($msgnum + 1))
85 echo "$msgnum" >"$dotest/msgnum"
89 cmt
="$(cat "$dotest/cmt.
$1")"
90 echo "$cmt" > "$dotest/current"
91 hd
=$
(git rev-parse
--verify HEAD
)
92 cmt_name
=$
(git symbolic-ref HEAD
2> /dev
/null ||
echo HEAD
)
93 msgnum
=$
(cat "$dotest/msgnum")
94 end
=$
(cat "$dotest/end")
95 eval GITHEAD_
$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
96 eval GITHEAD_
$hd='$(cat "$dotest/onto_name")'
97 export GITHEAD_
$cmt GITHEAD_
$hd
98 git-merge-
$strategy "$cmt^" -- "$hd" "$cmt"
102 unset GITHEAD_
$cmt GITHEAD_
$hd
110 echo "Strategy: $rv $strategy failed, try another" 1>&2
114 die
"Unknown exit code ($rv) from command:" \
115 "git-merge-$strategy $cmt^ -- HEAD $cmt"
120 move_to_original_branch
() {
121 test -z "$head_name" &&
122 head_name
="$(cat "$dotest"/head-name)" &&
123 onto
="$(cat "$dotest"/onto)" &&
124 orig_head
="$(cat "$dotest"/orig-head)"
127 message
="rebase finished: $head_name onto $onto"
128 git update-ref
-m "$message" \
129 $head_name $
(git rev-parse HEAD
) $orig_head &&
130 git symbolic-ref HEAD
$head_name ||
131 die
"Could not move back to $head_name"
137 move_to_original_branch
147 interactive_rebase
=explicit
150 -p|
--preserve-merges)
151 interactive_rebase
=implied
157 if [ "$interactive_rebase" = implied
]; then
162 test -n "$interactive_rebase" ||
test -f "$dotest"/interactive
165 run_pre_rebase_hook
() {
166 if test -z "$OK_TO_SKIP_PRE_REBASE" &&
167 test -x "$GIT_DIR/hooks/pre-rebase"
169 "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} ||
{
170 echo >&2 "The pre-rebase hook refused to rebase."
176 test -f "$GIT_DIR"/rebase-apply
/applying
&&
177 die
'It looks like git-am is in progress. Cannot rebase.'
179 is_interactive
"$@" && exec git-rebase--interactive
"$@"
183 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply || usage
184 test -d "$dotest" -o -f "$GIT_DIR"/rebase-apply
/rebasing
&&
185 die
'A rebase is in progress, try --continue, --skip or --abort.'
186 die
"No arguments given and $GIT_DIR/rebase-apply already exists."
193 OK_TO_SKIP_PRE_REBASE
=yes
196 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
197 die
"No rebase in progress?"
199 git diff-files
--quiet --ignore-submodules ||
{
200 echo "You must edit all merge conflicts and then"
201 echo "mark them as resolved using git add"
206 prev_head
=$
(cat "$dotest/prev_head")
207 end
=$
(cat "$dotest/end")
208 msgnum
=$
(cat "$dotest/msgnum")
209 onto
=$
(cat "$dotest/onto")
211 while test "$msgnum" -le "$end"
219 head_name
=$
(cat "$GIT_DIR"/rebase-apply
/head-name
) &&
220 onto
=$
(cat "$GIT_DIR"/rebase-apply
/onto
) &&
221 orig_head
=$
(cat "$GIT_DIR"/rebase-apply
/orig-head
) &&
222 git am
--resolved --3way --resolvemsg="$RESOLVEMSG" &&
223 move_to_original_branch
227 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
228 die
"No rebase in progress?"
230 git
reset --hard HEAD ||
exit $?
234 prev_head
=$
(cat "$dotest/prev_head")
235 end
=$
(cat "$dotest/end")
236 msgnum
=$
(cat "$dotest/msgnum")
237 msgnum
=$
(($msgnum + 1))
238 onto
=$
(cat "$dotest/onto")
239 while test "$msgnum" -le "$end"
247 head_name
=$
(cat "$GIT_DIR"/rebase-apply
/head-name
) &&
248 onto
=$
(cat "$GIT_DIR"/rebase-apply
/onto
) &&
249 orig_head
=$
(cat "$GIT_DIR"/rebase-apply
/orig-head
) &&
250 git am
-3 --skip --resolvemsg="$RESOLVEMSG" &&
251 move_to_original_branch
255 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
256 die
"No rebase in progress?"
261 move_to_original_branch
263 dotest
="$GIT_DIR"/rebase-apply
264 move_to_original_branch
266 git
reset --hard $
(cat "$dotest/orig-head")
271 test 2 -le "$#" || usage
275 -M|
-m|
--m|
--me|
--mer|
--merg|
--merge)
278 -s=*|
--s=*|
--st=*|
--str=*|
--stra=*|
--strat=*|
--strate=*|\
279 --strateg=*|
--strategy=*|\
280 -s|
--s|
--st|
--str|
--stra|
--strat|
--strate|
--strateg|
--strategy)
283 strategy
=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
296 git_am_opt
="$git_am_opt $1"
299 git_am_opt
="$git_am_opt $1"
314 # Make sure we do not have $GIT_DIR/rebase-apply
315 if test -z "$do_merge"
317 if mkdir
"$GIT_DIR"/rebase-apply
2>/dev
/null
319 rmdir "$GIT_DIR"/rebase-apply
322 It seems that I cannot create a rebase-apply directory, and
323 I wonder if you are in the middle of patch application or another
324 rebase. If that is not the case, please
325 rm -fr '"$GIT_DIR"'/rebase-apply
326 and run me again. I am stopping in case you still have something
333 die
"previous rebase directory $dotest still exists." \
334 'Try git rebase (--continue | --abort | --skip)'
338 # The tree must be really really clean.
339 if ! git update-index
--ignore-submodules --refresh; then
340 echo >&2 "cannot rebase: you have unstaged changes"
343 diff=$
(git diff-index
--cached --name-status -r --ignore-submodules HEAD
--)
345 ?
*) echo >&2 "cannot rebase: your index contains uncommitted changes"
351 if test -z "$rebase_root"
353 # The upstream head must be given. Make sure it is valid.
356 upstream
=`git rev-parse --verify "${upstream_name}^0"` ||
357 die
"invalid upstream $upstream_name"
359 upstream_arg
="$upstream_name"
361 test -z "$newbase" && die
"--root must be used with --onto"
365 upstream_arg
="$root_flag"
368 # Make sure the branch to rebase onto is valid.
369 onto_name
=${newbase-"$upstream_name"}
370 onto
=$
(git rev-parse
--verify "${onto_name}^0") ||
exit
372 # If a hook exists, give it a chance to interrupt
373 run_pre_rebase_hook
"$upstream_arg" "$@"
375 # If the branch to rebase is given, that is the branch we will rebase
376 # $branch_name -- branch being rebased, or HEAD (already detached)
377 # $orig_head -- commit object name of tip of the branch before rebasing
378 # $head_name -- refs/heads/<that-branch> or "detached HEAD"
382 # Is it "rebase other $branchname" or "rebase other $commit"?
386 if git show-ref
--verify --quiet -- "refs/heads/$1" &&
387 branch
=$
(git rev-parse
-q --verify "refs/heads/$1")
389 head_name
="refs/heads/$1"
390 elif branch
=$
(git rev-parse
-q --verify "$1")
392 head_name
="detached HEAD"
398 # Do not need to switch branches, we are already on it.
399 if branch_name
=`git symbolic-ref -q HEAD`
401 head_name
=$branch_name
402 branch_name
=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
404 head_name
="detached HEAD"
405 branch_name
=HEAD
;# detached
407 branch
=$
(git rev-parse
--verify "${branch_name}^0") ||
exit
412 # Now we are rebasing commits $upstream..$branch (or with --root,
413 # everything leading up to $branch) on top of $onto
415 # Check if we are already based on $onto with linear history,
416 # but this should be done only when upstream and onto are the same.
417 mb
=$
(git merge-base
"$onto" "$branch")
418 if test "$upstream" = "$onto" && test "$mb" = "$onto" &&
420 ! (git rev-list
--parents "$onto"..
"$branch" |
grep " .* ") > /dev
/null
422 # Lazily switch to the target branch if needed...
423 test -z "$switch_to" || git checkout
"$switch_to"
424 echo >&2 "Current branch $branch_name is up to date."
428 if test -n "$verbose"
430 echo "Changes from $mb to $onto:"
431 # We want color (if set), but no pager
432 GIT_PAGER
='' git
diff --stat --summary "$mb" "$onto"
435 # Detach HEAD and reset the tree
436 echo "First, rewinding head to replay your work on top of it..."
437 git checkout
-q "$onto^0" || die
"could not detach HEAD"
438 git update-ref ORIG_HEAD
$branch
440 # If the $onto is a proper descendant of the tip of the branch, then
441 # we just fast forwarded.
442 if test "$mb" = "$branch"
444 echo >&2 "Fast-forwarded $branch_name to $onto_name."
445 move_to_original_branch
449 if test -n "$rebase_root"
451 revisions
="$onto..$orig_head"
453 revisions
="$upstream..$orig_head"
456 if test -z "$do_merge"
458 git format-patch
-k --stdout --full-index --ignore-if-in-upstream \
459 $root_flag "$revisions" |
460 git am
$git_am_opt --rebasing --resolvemsg="$RESOLVEMSG" &&
461 move_to_original_branch
463 test 0 != $ret -a -d "$GIT_DIR"/rebase-apply
&&
464 echo $head_name > "$GIT_DIR"/rebase-apply
/head-name
&&
465 echo $onto > "$GIT_DIR"/rebase-apply
/onto
&&
466 echo $orig_head > "$GIT_DIR"/rebase-apply
/orig-head
470 # start doing a rebase with git-merge
471 # this is rename-aware if the recursive (default) strategy is used
474 echo "$onto" > "$dotest/onto"
475 echo "$onto_name" > "$dotest/onto_name"
477 echo "$prev_head" > "$dotest/prev_head"
478 echo "$orig_head" > "$dotest/orig-head"
479 echo "$head_name" > "$dotest/head-name"
482 for cmt
in `git rev-list --reverse --no-merges "$revisions"`
484 msgnum
=$
(($msgnum + 1))
485 echo "$cmt" > "$dotest/cmt.$msgnum"
488 echo 1 >"$dotest/msgnum"
489 echo $msgnum >"$dotest/end"
494 while test "$msgnum" -le "$end"